From d5a5a58e2e89aff06609be9ed5078832f13bdf0e Mon Sep 17 00:00:00 2001
From: Ralph Bean <rbean@redhat.com>
Date: Mar 15 2016 14:59:41 +0000
Subject: [PATCH 330/1001] Merge #105 `Fixing issue #96(Meetings Widget: Conditional display of Timestamp) and Issue #106 ( layout of github PR widget)`


---

diff --git a/hubs/widgets/github_pr.py b/hubs/widgets/github_pr.py
old mode 100644
new mode 100755
index 6a33091..ff890aa
--- a/hubs/widgets/github_pr.py
+++ b/hubs/widgets/github_pr.py
@@ -17,47 +17,52 @@ log = logging.getLogger(__name__)
 chrome = panel("Github: Pull Requests")
 
 template = jinja2.Template("""
-  <br />
-  {% for i in range(display_number) %}
-    <div>
-      <table class="table-responsive table-condensed">
-        <tr>
-          <td valign="top" class="panel-heading">
-            <b>#{{ pulls[i]['number'] }}</b>
-          </td>
-          <td width="300px">
-            <b>{{ pulls[i]['title'] }}</b>
-          </td>
-        </tr>
-      </table>
-      <table class="table-responsive table-condensed">
-        <tr>
-          <td width="300px">
-            <font size="2">
-              <i>Opened by <a href="https://github.com/{{ pulls[i]['user'] }}" target="_blank">{{ pulls[i]['user'] }}</a></i>
-              {% if pulls[i]['assignee']|string() == "None" %}
-                <br /><i>Unclaimed</i>
-              {% else %}
-                 <br /><i>Assigned by <a href="https://github.com/{{ pulls[i]['assignee'] }}" target="_blank">{{ pulls[i]['assignee'] }}</a></i>
-              {% endif %}
-            </font>
-          </td>
-          <td>
-             <a href="{{ pulls[i]['url'] }}" target="_blank">
-               <button type="button" class="btn btn-default" aria-label="Left Align">
-                 <span class="glyphicon glyphicon-chevron-right" aria-hidden="true"></span>
-               </button>
-             </a>
-          </td>
-        </tr>
-      </table>
-    </div>
-    {% endfor %}
-    {% if more != 0 %}
-    <div class="row">
-      <a href="https://github.com/{{ organization }}" target="_blank"><center>and {{ more }} more</center></a>
-    </div>
-    {% endif %}
+<a class="btn btn-success" target="_blank"
+    href="https://github.com/{{ organization }}" >
+  Organization Github Page
+</a>
+<hr/>
+
+  {% for pr in pulls[:display_number] %}
+    <li class="media">
+      <div class="media-left">
+        <a  href="{{ pr['url'] }}" 
+            target="_blank">
+        <span class="label label-default">#{{ pr['number'] }}</span>
+        </a>
+      </div>
+      <div class="media-body">
+        <h4 class="media-heading">
+          {{ organization }} -
+          <span title="{{ pr['title'] }}">
+            {{ pr['title'] }} {% if
+              pr['title'] | length > 45 %} ... {% endif %}
+          </span>
+        </h4>
+        Opened by:
+          <a href="https://github.com/{{ pr['user'] }}" 
+              target="_blank">
+            {{ pr['user'] }}
+          </a>
+        --
+        {% if pr['assignee'] %}
+          Assigned to:
+          <a href="https://github.com/{{ pr['assignee'] }}"
+              target="_blank">
+            {{ pr['assignee'] }}
+          </a>
+        {% else %}
+          <span class="text-muted">Unassigned</span>
+        {% endif %}
+      </div>
+    </li>
+  {% endfor %}
+  {% if all_pr | length > display_number %}
+  <li>
+    And {{ all_pr | length - display_number }} more ...
+  </li>
+  {% endif %}
+</ul>
 """)
 
 
diff --git a/hubs/widgets/meetings.py b/hubs/widgets/meetings.py
old mode 100644
new mode 100755
index 1dfd8ec..c3a8382
--- a/hubs/widgets/meetings.py
+++ b/hubs/widgets/meetings.py
@@ -16,19 +16,31 @@ chrome = panel('Reminders', key='meetings')
 def next_meeting(meetings):
     now = datetime.datetime.utcnow()
     for meeting in meetings:
-        string = "%s %s" % (meeting['meeting_date'],
+        start_string = "%s %s" % (meeting['meeting_date'],
                             meeting['meeting_time_start'])
-        dt = datetime.datetime.strptime(string, "%Y-%m-%d %H:%M:%S")
+        start_dt = datetime.datetime.strptime(start_string, "%Y-%m-%d %H:%M:%S")
 
-        if now < dt:
-            meeting['human_time'] = arrow.get(dt).humanize()
-            meeting['start_date'] = dt.strftime('%b %d')
+        stop_string = "%s %s" % (meeting['meeting_date_end'],
+                            meeting['meeting_time_stop'])
+        stop_dt = datetime.datetime.strptime(stop_string, "%Y-%m-%d %H:%M:%S")
+
+        if now < start_dt:
+            meeting['human_time'] = arrow.get(start_dt).humanize()
+            meeting['start_date'] = start_dt.strftime('%b %d')
+            meeting['stop_date'] = stop_dt.strftime('%b %d')
+            meeting['display_time'] = True
+            meeting['display_duration'] = False            
             # Just UTC for now until we do this on the client and can access
             # their local with moment.js.
             meeting['start_time'] = meeting['meeting_time_start'][:-3] + " UTC"
+            meeting['stop_time'] = meeting['meeting_time_stop'][:-3] + " UTC"
             meeting['location'] = meeting['meeting_location']
             if '@' in meeting['location']:
                 meeting['location'] = '#' + meeting['location'].split('@')[0]
+            if stop_dt - start_dt >= datetime.timedelta(hours=24) :
+                meeting['display_time'] = False
+                if stop_dt - start_dt > datetime.timedelta(hours=24) :
+                    meeting['display_duration'] = True
             return meeting
 
     return None
@@ -41,9 +53,15 @@ template = jinja2_environment.from_string("""
         {% set next = items | next_meeting %}
         {% if next %}
         <p>The {{ next.meeting_name }} is {{ next.human_time }}</p>
+        {% if next.display_duration %}
+        <h1 class='inline'>{{next.start_date}} - {{next.stop_date}}</h1>
+        {% else %}
         <h1 class='inline'>{{next.start_date}}</h1>
+        {% endif %}
         <div class='inline'>
+            {% if next.display_time %}
             @{{next.start_time}}<br/>
+            {% endif %}
             {{next.location}}<br/>
             {{next.meeting_information_html}}
         </div>
